# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = [
    'GetPlansResult',
    'AwaitableGetPlansResult',
    'get_plans',
    'get_plans_output',
]

@pulumi.output_type
class GetPlansResult:
    """
    A collection of values returned by getPlans.
    """
    def __init__(__self__, filters=None, id=None, plans=None, sorts=None):
        if filters and not isinstance(filters, list):
            raise TypeError("Expected argument 'filters' to be a list")
        pulumi.set(__self__, "filters", filters)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if plans and not isinstance(plans, list):
            raise TypeError("Expected argument 'plans' to be a list")
        pulumi.set(__self__, "plans", plans)
        if sorts and not isinstance(sorts, list):
            raise TypeError("Expected argument 'sorts' to be a list")
        pulumi.set(__self__, "sorts", sorts)

    @property
    @pulumi.getter
    def filters(self) -> Optional[Sequence['outputs.GetPlansFilterResult']]:
        return pulumi.get(self, "filters")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def plans(self) -> Sequence['outputs.GetPlansPlanResult']:
        return pulumi.get(self, "plans")

    @property
    @pulumi.getter
    def sorts(self) -> Optional[Sequence['outputs.GetPlansSortResult']]:
        return pulumi.get(self, "sorts")


class AwaitableGetPlansResult(GetPlansResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetPlansResult(
            filters=self.filters,
            id=self.id,
            plans=self.plans,
            sorts=self.sorts)


def get_plans(filters: Optional[Sequence[Union['GetPlansFilterArgs', 'GetPlansFilterArgsDict']]] = None,
              sorts: Optional[Sequence[Union['GetPlansSortArgs', 'GetPlansSortArgsDict']]] = None,
              opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetPlansResult:
    """
    Use this data source to access information about an existing resource.

    :param Sequence[Union['GetPlansFilterArgs', 'GetPlansFilterArgsDict']] filters: One or more attribute/values pairs to filter off of
    :param Sequence[Union['GetPlansSortArgs', 'GetPlansSortArgsDict']] sorts: One or more attribute/direction pairs on which to sort results. If multiple sorts are provided, they will be applied in order
    """
    __args__ = dict()
    __args__['filters'] = filters
    __args__['sorts'] = sorts
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('equinix:metal/getPlans:getPlans', __args__, opts=opts, typ=GetPlansResult).value

    return AwaitableGetPlansResult(
        filters=pulumi.get(__ret__, 'filters'),
        id=pulumi.get(__ret__, 'id'),
        plans=pulumi.get(__ret__, 'plans'),
        sorts=pulumi.get(__ret__, 'sorts'))


@_utilities.lift_output_func(get_plans)
def get_plans_output(filters: Optional[pulumi.Input[Optional[Sequence[Union['GetPlansFilterArgs', 'GetPlansFilterArgsDict']]]]] = None,
                     sorts: Optional[pulumi.Input[Optional[Sequence[Union['GetPlansSortArgs', 'GetPlansSortArgsDict']]]]] = None,
                     opts: Optional[pulumi.InvokeOptions] = None) -> pulumi.Output[GetPlansResult]:
    """
    Use this data source to access information about an existing resource.

    :param Sequence[Union['GetPlansFilterArgs', 'GetPlansFilterArgsDict']] filters: One or more attribute/values pairs to filter off of
    :param Sequence[Union['GetPlansSortArgs', 'GetPlansSortArgsDict']] sorts: One or more attribute/direction pairs on which to sort results. If multiple sorts are provided, they will be applied in order
    """
    ...
